package com.danitheskunk.skunkworks.nodes;

import com.danitheskunk.skunkworks.Vec2f;
import com.danitheskunk.skunkworks.gfx.IRenderContext;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

//todo: figure out the whole translation position thingie

public class Node implements Iterable<Node> {
	protected List<Node> children;
	protected Node parent;
	protected Vec2f pos;

	public Node() {
		children = new ArrayList<>();
		parent = null;
		pos = Vec2f.ZERO;
	}

	public Vec2f getPos() {
		return pos;
	}

	public void setPos(Vec2f pos) {
		this.pos = pos;
	}

	public void add(Node node) {
		if(node.parent != null) {
			throw new RuntimeException("Can't add node to two nodes");
		}
		node.parent = this;
		children.add(node);
	}

	public void remove(Node node) {
		node.parent = null;
		children.remove(node);
	}

	public void render(IRenderContext rc) {
		for(var child : this) {
			child.render(rc);
		}
	}

	public Vec2f getAbsolutePos() {
		if(parent == null) return pos;
		return Vec2f.add(parent.getAbsolutePos(), pos);
	}

	@Override
	public Iterator<Node> iterator() {
		return children.iterator();
	}
}
